from typing import Any, Dict, List, Tuple

import regex as re

from src.detections import NumberDetection
from src.detectors.interface import Detector

NUMBER_REGEX = re.compile(
    r"\d+",
    re.I,
)


class NumberDetector(Detector):
    def __init__(self) -> None:
        super().__init__()

    def detect(
        self, text: str, annotations: Dict[str, List[Tuple[int, int, Any]]]
    ) -> List[Tuple[int, int, NumberDetection]]:

        numbers = []

        for number in NUMBER_REGEX.finditer(text):
            numbers.append((number.start(), number.end(), NumberDetection()))

        return numbers
