from abc import ABC, abstractmethod
from typing import List, Optional, Type

from src.detections import Detection


class MorphosyntacticDictionary(ABC):
    @abstractmethod
    def get_supported_detection_classes(self) -> List[Type[Detection]]:
        """
        Returns a list of supported detection classess
        """

    def get_random_replacement(self, original_entry: Detection) -> Optional[str]:
        """
        Returns a random replacement for the original entry
        """
