from hydra import compose, initialize
from hydra.utils import instantiate


def test_wiktorner_jsonl_configuration():
    with initialize(config_path="../../../config", version_base="1.1"):
        config = compose(
            config_name="config",
            overrides=["paths.root_path=../../../", "configuration=wiktorner_jsonl"],
        )
        pipeline = instantiate(config.pipeline)

    result = pipeline.run(
        "./tests/integration/wiktorner_jsonl_configuration/wiktorner_jsonl.jsonl"
    )

    assert (
        result
        == '{"text": "ROZDZIAŁ I. CO NIECO O SAMEJ PIPIDÓWCE Przede wszystkim muszę uprzedzić z góry czytelników, aby się daremnie nie trudzili nad szukaniem wyżej wyrażonego miasteczka na mapach [MIEJSCE] i [MIEJSCE], bo go tam nie znajdą. Nie dlatego, jakoby [MIEJSCE] nie istniała w rzeczywistości i była tylko wytworem fantazji autora, ale po prostu dlatego, że mieszkańcy owego sławnego grodu, urosłszy z czasem w ambicję, uważali tę nazwę jako ubliżającą ich powadze i podali do c. k. namiestnictwa pokorną prośbę o pozwolenie zamienienia jej na inną. Podobne zamiany nazwisk praktykują się dość często w [MIEJSCE], szczególnie u pojedynczych osób, które nie czując się na siłach uszlachetnienia sobą, swymi czynami własnego nazwiska, chcą nazwiskiem uszlachetnić siebie, i tak np."}'
    )
