from src.detections import (CityDetection, DateDetection, NameDetection,
                            SurnameDetection)
from src.replacers.tag_replacer import TagReplacer


def test_replace_with_tags():
    text = "Ala Brzeszczot urodziła sie 05.05.2005 we Wrocławiu"
    detections = [
        (0, 3, NameDetection()),
        (4, 14, SurnameDetection()),
        (28, 38, DateDetection()),
        (42, 51, CityDetection()),
    ]

    replacer = TagReplacer()

    result = replacer.replace(text, detections)

    expected_text = "[OSOBA] [OSOBA] urodziła sie [DATA] we [MIEJSCE]"
    exptected_detections_left = []

    assert result == (expected_text, exptected_detections_left)
